#!/bin/bash -i
# -- note the -i part in the above line (check that .bashrc is pretty default)
# -- prototype script

echo "Run this script in an empty folder."
echo "This probably only works on YouTube videos which have comments which have replies where all of the replies are not shown."
sleep 0.5
echo "YouTube video ID: $1"
echo "YouTube API key: $2"
curl "https://www.googleapis.com/youtube/v3/commentThreads?key=$2&part=snippet,replies&videoId=$1&maxResults=100" > "$1.txt"

# -- Download all pages of the comments
nextpage=$(cat "$1.txt" | grep '"nextPageToken"' | awk {'print $2'} | sed "s/\"\|,//g")
if [ -n "$nextpage" ]; then
    echo "nextPageToken found."
    while [ -n "$nextpage" ];
    do
        nextpagedup=$nextpage
        curl "https://www.googleapis.com/youtube/v3/commentThreads?key=$2&part=snippet,replies&videoId=$1&maxResults=100&maxResults=100&pageToken=$nextpage" >> "$1.txt"
        nextpage=$(cat "$1.txt" | grep '"nextPageToken"' | tail -n 1 | awk {'print $2'} | sed "s/\"\|,//g")
        echo "Old nextpage: $nextpagedup"
        echo "New nextpage: $nextpage"
        sleep 0.7
        if [[ "$nextpagedup" == "$nextpage" ]]; then
            echo "No new nextPageToken found."
            break
        fi
    done
else
    echo "nextPageToken not found (there is none)."
fi

# -- Download missing replies
echo 'execute "%s/\\(.\\+\\n\\)\\{28} \\{8}\"totalReplyCount\":\\s\\([1-9]\\|\\d\\d\\+\\),\\(\\n.\\+\\)\\{3}\\n\\( \\{4}{\\)/\\4/ge"' > vim.txt
echo 'execute "%s/\\(.\\+\\n\\)\\{28} \\{8}\"totalReplyCount\": 0,\\(\\n.\\+\\)\\{3}//ge"' >> vim.txt
echo 'execute "%s/\\(.\\+\\n\\)\\{6} \\{14}\"textDisplay\": \"\\(.\\+\\n\\)\\{15}.\\+/./ge"' >> vim.txt
echo 'execute "%s/\\(^\\.$\\n\\)\\+/\\=strlen(substitute(submatch(0), \"\\n\", \"\", \"g\")) . \"\\r\""' >> vim.txt
echo 'execute "%s/^ \\{8}\"totalReplyCount\": \\(\\d\\+\\),\\(\\n.\\+\\)\\{4}\\n\\1/---Has all replies/ge"' >> vim.txt
echo 'execute "%s/^ \\{8}\"totalReplyCount\": \\(\\d\\+\\),\\(\\n.\\+\\)\\{4}\\n\\d\\+/---Does NOT have all replies/ge"' >> vim.txt
echo 'execute "g!/^---\\|^ \\{6}\"id\"/d"' >> vim.txt
echo 'execute "%s/^\\s\\+\"id\":.\\+\\n---Has all replies\\n//g"' >> vim.txt
echo 'execute "%s/^\\s\\+\"id\": \"\\([^\"]\\+\\)\",\\n---Does NOT have.\\+/curl \"https:\\/\\/www.googleapis.com\\/youtube\\/v3\\/comments?key=[KEY_HERE]\\&part=snippet,id\\&parentId=\\1\\&maxResults=100\" --header \"Accept: application\\/json\" > \\1.json/g"' >> vim.txt
echo 'execute "w dl_missing.sh | q!"' >> vim.txt
vim "$1.txt" -c 'execute "so vim.txt"'
cat "dl_missing.sh" | sed "s/\[KEY_HERE\]/$2/g" > "download_missing.sh"
rm "dl_missing.sh"
bash "download_missing.sh"

# -- Patch in missing replies
cp "$1.txt" "$1_patched.txt"
dlmissing=$(cat download_missing.sh | sed "s/.\+ //g")
# -- Do not run '; vim "$one" -c "execute \"so ""$args""_do.txt\""' in xargs, it breaks GNOME Terminal
echo -en "$dlmissing" | xargs -d "\n" sh -c 'for args do one=$(ls | grep _patched.txt | tr -d \\n); argsnojson=$(echo -n $args | sed s/.json//g); echo "execute \"edit $args\"" > ""$args""_do.txt; echo "execute \"%s/^/\\\\\=\\\"\\\\\x20\\\\\x20\\\\\x20\\\\\x20\\\\\x20\\\\\x20\\\"/g | %s/ \\\"items\\\": / \\\"comments\\\": /g\"" >> ""$args""_do.txt; echo "execute \"normal! gg6ddGddgg\\\"ayG\"" >> ""$args""_do.txt; echo "execute \"bdelete!""\"" >> ""$args""_do.txt; echo "execute \"edit $one\"" >> ""$args""_do.txt; echo "execute \"%s/^\\\\\( \\\\\{10}\\\"id\\\": \\\"$argsnojson\\\".*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\\\\n.*\\\\\)\\\\\\\\n \\\\\{8}\\\"comments\\\": \\\\\(.\\\\\+\\\\\\\\n\\\\\)\\\\\{-} \\\\\{8}\\\\\]\\\\\\\\n/\\\\\\\\1\\\\\\\\r\\\"\\\"\\\"\\\"\\\"/g | %s/\\\"\\\"\\\"\\\"\\\"/\\\\\=@a/g\"" >> ""$args""_do.txt; echo "execute \"wq\"" >> ""$args""_do.txt; echo "vim \"$one\" -c \"execute \\\"so ""$args""_do.txt\\\"\"" >> do.txt; done' _
# -- todo: make a loop which execute each line instead of doing the following
eval $(tail +1 do.txt | head -n 1)
eval $(tail +2 do.txt | head -n 1)
#$(tail +3 do.txt | head -n 1)
#$(tail +4 do.txt | head -n 1)
#$(tail +5 do.txt | head -n 1)
#$(tail +6 do.txt | head -n 1)
#$(tail +7 do.txt | head -n 1)
#$(tail +8 do.txt | head -n 1)
#$(tail +9 do.txt | head -n 1)
#$(tail +10 do.txt | head -n 1)
#$(tail +11 do.txt | head -n 1)
#$(tail +12 do.txt | head -n 1)
#$(tail +13 do.txt | head -n 1)
#$(tail +14 do.txt | head -n 1)
#$(tail +15 do.txt | head -n 1)
#$(tail +16 do.txt | head -n 1)
#$(tail +17 do.txt | head -n 1)
#$(tail +18 do.txt | head -n 1)
#$(tail +19 do.txt | head -n 1)
#$(tail +20 do.txt | head -n 1)
#$(tail +21 do.txt | head -n 1)
#$(tail +22 do.txt | head -n 1)
